'****************************************************************************
'
' UKAW Paket   : E-MAIL
' Version      : 1.35g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound/CrossPoint
'            or: www.basicguru.com/pbsound-hq/pbsources.win
' Last Updates : see directly in the sources
'
' all original sources by Karl-Heinz Weiss
'
'****************************************************************************

$RESOURCE "UKAW.PBR"
$INCLUDE "WIN32API.INC"
$INCLUDE "WSOCK32.INC"
$INCLUDE "UKAW.INC"
$INCLUDE "UKAWLOG.BAS"

DEFLNG a-z
%wsock_version= &h0101
%buflen=30000
DECLARE FUNCTION SetPriorityClass LIB "KERNEL32.DLL" ALIAS "SetPriorityClass" (BYVAL hProcess AS LONG, BYVAL dwPriorityClass AS LONG) AS LONG
DECLARE SUB Sleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS LONG)
DECLARE SUB usage()
DECLARE FUNCTION CommandLine(Host$, Port, Helo$, Mask$)
DECLARE FUNCTION Login(SmtpHelo$)
DECLARE FUNCTION NextFile (a$)
DECLARE FUNCTION ParseAdress$ (aa$)
DECLARE FUNCTION SendAll(Mask$)
DECLARE FUNCTION SendMail(file$, mfrom$, mto$)

GLOBAL rcvbuf AS STRING * %buflen
GLOBAL crlf$
GLOBAL Host$
'/// v1.35g, +Helo$ als Global zum bergehen von fehlerhaften eMail's
'/// z.B. durch falsche Adressen, fehlerhafte Header etc.
GLOBAL Helo$
GLOBAL lpr AS DWORD, lpw AS DWORD, s AS DWORD,hlisten&

FUNCTION listenthread
   DO
      sleep 1
      IF lpr> lpw THEN
         maxtransfer = lpr - lpw-1
      ELSE
         maxtransfer = %buflen-lpw
         IF lpw+maxtransfer>=%buflen AND lpr=0 THEN
            DECR maxtransfer
         END IF
      END IF
      n=recv(s,BYVAL VARPTR(rcvbuf)+lpw,maxtransfer,0)
      IF n>0 THEN
        lpw=lpw+n
        IF lpw>=%buflen THEN
           lpw=0
        END IF
     END IF
   LOOP
END FUNCTION

FUNCTION ConnectTo (Host$, Port)
    DIM wsaData AS WSAdata
    DIM pHostEnt AS hostentStru PTR
    DIM in_addr AS in_addr
    DIM servent AS servent PTR
    DIM sockAddr AS SOCKADDR_IN
    DIM dip_addr AS ASCIIZ PTR
    DIM host_name AS ASCIIZ*64
    FUNCTION = -1
    host_name = host$
    FUNCTION = %invalid_socket
    IF WSAStartup(%wsock_version,WSAdata) THEN
        WSACleanup
        Logwrite "WSAStartup failed!", -1, %LogState_FatalError
        EXIT FUNCTION
    END IF
    Ip_adr???=inet_addr(host_name)
    IF Ip_adr??? = %INADDR_NONE THEN
        pHostEnt=gethostbyname(host_name)
        IF ISFALSE pHostEnt THEN
            WSACleanup
            Logwrite "GetHostByName failed!", -1, %LogState_FatalError
            EXIT FUNCTION
        ELSE
            in_addr.s_addr=@pHostEnt.@@h_list
            dip_addr=inet_ntoa(in_addr.s_addr)
        END IF
    ELSE
        in_addr.s_addr=Ip_adr???
    END IF
    s= socket(%PF_INET,%SOCK_STREAM,%IPPROTO_TCP)
    IF s=%INVALID_SOCKET THEN
        WSACleanup
        Logwrite "Invalid Socket!", -1, %LogState_FatalError
        EXIT FUNCTION
    END IF
 
    sockAddr.sin_family=%AF_INET
    sockAddr.sin_port=htons(port)
    sockAddr.sin_addr=in_addr
    IF connect(s,sockAddr,SIZEOF(sockAddr))<>0 THEN
       WSACleanup
       Logwrite "Connection failure!", -1, %LogState_FatalError
       EXIT FUNCTION
    END IF
    cmd& = %FIONBIO
    argp& = 1
'    n& = ioctlsocket( s, cmd&, argp& )
    ' /// v1.10g On, WSocket-Init mu abgeschlossen sein, ansonsten kann ///
    ' /// kann es zu Strungen in der Modacom-API kommen.
    THREAD CREATE ListenThread(s) TO hLISTEN&
    ' /// v1.00g Off ///
    FUNCTION=0
END FUNCTION

FUNCTION sendstring(a$)AS INTEGER
    u%=send(s,BYVAL STRPTR(a$),LEN(a$),0)
    IF u%=%socket_error THEN FUNCTION=-1
END FUNCTION

FUNCTION sendline(a$)AS INTEGER
   c$=a$+CHR$(13)+CHR$(10)
   FUNCTION=sendstring(c$)
END FUNCTION

FUNCTION linput(r$) AS INTEGER
  r$=""
  tout=5000
  DO
    IF lpw>lpr THEN
       r$=MID$(rcvbuf,lpr+1,lpw-lpr)
       p=INSTR(r$,crlf$)
       IF p>0 THEN
          r$=LEFT$(r$,p-1)
          lpr=lpr+p+1
          EXIT FUNCTION
       END IF
    ELSEIF lpr>lpw THEN
       r$=MID$(rcvbuf,lpr+1,%buflen-lpr)+LEFT$(rcvbuf,lpw)
       p=INSTR(r$,crlf$)
       IF p>0 THEN
          r$=LEFT$(r$,p-1)
          lpr=lpr+p+1
          IF lpr>%buflen-1 THEN lpr=lpr-%buflen
          EXIT FUNCTION
       END IF
    END IF
    sleep 10
    tout=tout-1
  LOOP
  STDOUT
  LogWrite "ERROR ON NETWORK (Timeout).", -1, %LogState_FatalError
  FUNCTION = -1
END FUNCTION


FUNCTION CommandLine(Host$, Port, Helo$, Mask$)
    FUNCTION = -1
    cmd$ = COMMAND$
    IF cmd$ = "" THEN
        CALL Usage
        EXIT FUNCTION
    END IF
    p = PARSECOUNT(cmd$)
    IF p > 1 THEN opt$ = PARSE$(cmd$, 2)
    IF p > 0 THEN
          Host$ = PARSE$(cmd$, 1)
          p = PARSECOUNT(Host$, " ")
          IF p > 1 THEN
             Port  = VAL(PARSE$(Host$, " ", 2))
             Host$ = PARSE$(Host$, " ", 1)
          END IF
    END IF
    IF Port = 0 THEN Port = 25
    IF Host$ = "" THEN
       LINE INPUT "Host: " Host$
    END IF
    IF INSTR(Host$, "?") THEN
       CALL Usage
       EXIT FUNCTION
    END IF
    IF Host$ = "" THEN
       CALL Usage
       EXIT FUNCTION
    END IF
    IF opt$ > "" THEN
       opt$ = LCASE$(opt$)
       p = INSTR(opt$,"-helo=")
       IF p THEN
          Helo$ = TRIM$(EXTRACT$(MID$(opt$,p+6)," "))
          opt$ = LEFT$(opt$, p - 1) + MID$(opt$, p + 6 + LEN(Helo$))
       END IF
       Mask$ = TRIM$(opt$)
    END IF
    IF Helo$ = "" THEN
       Helo$ = Host$
       p = INSTR(Helo$,".")
       IF VAL(Helo$) = 0 THEN
           IF p > 0 THEN
               Helo$ = MID$(Helo$, p + 1)
           ELSE
               Helo$ = "me"
           END IF
       ELSE
           Helo$ = "me"
       END IF
    END IF
    IF Mask$ = "" THEN
       Mask$ = ".\spool\m????.out"
       IF DIR$(".\spool",16) = "" THEN MKDIR ".\spool"
       IF DIR$(".\spool",16) = "" THEN
          LogWrite ".\spool doesn't exist!", -1, %LogState_FatalError
          EXIT FUNCTION
       END IF
    END IF
    FUNCTION = 0
END FUNCTION

SUB Usage
    STDOUT "E-MAIL " + Version$ + "                           (Freeware sources by Karl-Heinz Weiss)"
    STDOUT "                                                   compilation by " + Author$
    STDOUT " "
    STDOUT "Usage: e-mail host [Portnbr][,options]"
    STDOUT "Options: [-helo=host|domain] [dest-dir][filemask]"
    IF DIR$("e-mail.hlp") > "" THEN
        f = FREEFILE
        OPEN "e-mail.hlp" FOR INPUT AS #f
    ELSE
        EXIT SUB
    END IF
    i = 0
    DO WHILE NOT EOF(f)
       LINE input#f,a$
       PRINT a$
       i = i + 1
       IF i = 24 THEN
          PRINT SPACE$(37);"-more- ";
          a$ = WAITKEY$
          PRINT
          IF LCASE$(a$)="q" THEN EXIT DO
          i=0
       END IF
    LOOP
    CLOSE #f
END SUB

SUB lineinput (f,a$)
   STATIC buffer AS STRING
   STATIC fp AS LONG
   IF f > 0 THEN
      IF a$ <> "" THEN
        OPEN a$ FOR BINARY AS f
        GET$ f, LOF(f), buffer
        CLOSE f
      END IF
      fp = 1
      f = 0
      EXIT SUB
   END IF
   f=0
   IF fp<=LEN(buffer) THEN
      a$=EXTRACT$(fp,buffer,CHR$(10))
      fp=fp+LEN(a$)+1
      a$=EXTRACT$(a$,CHR$(13))
   ELSE
      buffer=""
      a$=""
      f=-1
   END IF
END SUB

FUNCTION sendcmd(cmd$,ack$)AS INTEGER
     FUNCTION=-1
     IF cmd$>"" THEN
        IF sendline(cmd$) THEN EXIT FUNCTION
     END IF
     IF linput(a$) THEN EXIT FUNCTION
     IF UCASE$(LEFT$(a$, LEN(ack$))) <> ack$ THEN EXIT FUNCTION
     ack$=a$
     FUNCTION=0
END FUNCTION

FUNCTION Login(SmtpHelo$)
    FUNCTION = -1
    IF linput (a$) THEN EXIT FUNCTION
    PRINT a$
    LogWrite SmtpHelo$, -1, %LogState_SessionInfo
    IF Sendline(SmtpHelo$) THEN EXIT FUNCTION
    DO
       IF linput (a$) THEN EXIT FUNCTION
       LogWrite a$, -1, %LogState_SessionInfo
       'PRINT a$
    LOOP WHILE VAL(a$)=220 OR MID$(a$, 4,1) = "-"
    IF VAL(a$) <> 250 THEN EXIT FUNCTION
    FUNCTION = 0
END FUNCTION

FUNCTION ParseAdress$ (aa$)
     pp = INSTR(aa$, "(")
     IF pp THEN aa$ = LEFT$(aa$, pp - 1)
     pp = INSTR(aa$, "<")
     IF pp THEN
       aa$ = MID$(aa$, pp + 1)
       pp = INSTR(aa$, ">")
       IF pp THEN aa$ = LEFT$(aa$, pp - 1)
     END IF
     FUNCTION= LTRIM$(RTRIM$(aa$))
END FUNCTION

FUNCTION MakeWRK(f$,env$())
   FUNCTION=-1
   f=FREEFILE
   i=1
   env$(i)=""
   lineinput f,f$
   a$=""
   DO
      IF a$="" THEN
         LINEINPUT f,c$
         IF c$="" THEN EXIT DO
      ELSE
         c$=a$
      END IF
      LINEINPUT f,a$
      IF c$="" THEN EXIT DO
      DO WHILE LEFT$(a$,1)=" " OR LEFT$(a$,1)=CHR$(9)
         c$=c$+a$
         LINEINPUT f,a$
      LOOP
      REPLACE CHR$(9) WITH " " IN c$
      IF INSTR(LCASE$(c$),"from: ")=1 THEN
             env$(0)=parseadress$(MID$(c$,7))
      ELSEIF INSTR(LCASE$(c$),"to: ")=1 OR _
             INSTR(LCASE$(c$),"cc: ")=1 OR _
             INSTR(LCASE$(c$),"bcc: ") THEN
             p=INSTR(c$," ")
             c$=MID$(c$,p+1)
             p=PARSECOUNT(c$,",")
             FOR k=1 TO p
                 env$(i)=parseadress$(PARSE$(c$,",",k))
                 INCR i
                 env$(i)=""
                 IF i>=1000 THEN
                    LogWrite "Too many (>999) recipients!", -1, %LogState_OtherError
                    EXIT DO
                 END IF
             NEXT
      END IF
      IF a$="" THEN EXIT DO
   LOOP
   FUNCTION=0
END FUNCTION

FUNCTION sendenvelope(f$)
      FUNCTION=-1
      DIM env$(1000)
      IF MakeWRK(f$,env$()) THEN EXIT FUNCTION
      a$="MAIL FROM:<"+env$(0)+">"
      LogWrite a$, -1, %LogState_Normal
      IF sendline(a$) THEN EXIT FUNCTION
      IF linput(a$) THEN EXIT FUNCTION
      LogWrite a$, -1, %LogState_Normal
      IF VAL(a$)<>250 THEN EXIT FUNCTION
      i=1
      DO WHILE env$(i)<>""
        a$="RCPT TO:<"+env$(i)+">"
        LogWrite a$, -1, %LogState_Normal
        IF sendline(a$) THEN EXIT FUNCTION
        IF linput(a$) THEN EXIT FUNCTION
        IF VAL(a$) <> 250 THEN
            '/// Fehler im Header (Empfnger/Domain unbekannt etc.) ///
            LogWrite a$, -1, %LogState_OtherError
            EXIT FUNCTION
        ELSE
            LogWrite a$, -1, %LogState_Normal
        END IF
        INCR i
      LOOP
      FUNCTION = 0
END FUNCTION

FUNCTION SendAll(Mask$)
    FUNCTION = -1
    f$ = DIR$(Mask$)
    FOR i = LEN(Mask$) TO 1 STEP -1
        IF MID$(Mask$,i,1) = ":" OR MID$(Mask$,i,1) = "\" THEN EXIT FOR
    NEXT
    Path$ = LEFT$(Mask$,i)
    DO WHILE f$ > ""
        b$ = ""
        IF SendEnvelope(Path$ + f$) THEN
            '/// v1.35g, falls Fehler auftritt -> berspringen, ///
            '/// mit HELO abbrechen und SMTP-Server Neu-Init    ///
            a$ = "HELO " + Helo$
            LogWrite a$, -1, %LogState_SessionInfo
            IF Sendline(a$) THEN EXIT FUNCTION
            DO
               IF linput (a$) THEN EXIT FUNCTION
               LogWrite a$, -1, %LogState_SessionInfo
            LOOP WHILE VAL(a$) = 220 OR MID$(a$, 4,1) = "-"
        ELSE
            IF SendLine("DATA") THEN EXIT FUNCTION
            IF linput(a$) THEN EXIT FUNCTION
            PRINT a$
            IF VAL(a$)<>354 THEN EXIT FUNCTION
            PRINT "         Sending "+f$;
            n = 0
            f = FREEFILE
            lineinput f,""
            hdr = 0
            DO WHILE f = 0
                LINEINPUT f, a$
                IF a$ = "" THEN hdr = -1
                IF hdr=0 THEN
                    IF INSTR(LCASE$(a$),"bcc: ") = 1 OR INSTR(a$,"From ") = 1 THEN
                        DO
                            LINEINPUT f,a$
                        LOOP WHILE LEFT$(a$,1) = " " OR LEFT$(a$,1) = CHR$(9)
                        IF a$ = "" THEN hdr = -1
                    END IF
                END IF
                b$ = b$ + a$ + crlf$
                n = n + LEN(a$)
                IF n >= 10000 THEN
                    n1 = n1 + n
                    LOCATE ,1
                    PRINT n1;
                    n = 0
                    IF SendLine(b$) THEN EXIT FUNCTION
                    b$ = ""
                END IF
            LOOP
            IF SendLine(b$) THEN EXIT FUNCTION
            PRINT
            IF SendLine (".") THEN EXIT FUNCTION
            IF linput (a$) THEN EXIT FUNCTION
            PRINT a$
            IF VAL(a$) <> 250 THEN EXIT FUNCTION
            KILL path$ + f$
        END IF
        f$ = DIR$
    LOOP
    a$ = "QUIT"
    LogWrite a$, -1, %LogState_Normal
    IF SendLine (a$) THEN EXIT FUNCTION
    IF linput (a$) THEN EXIT FUNCTION
    PRINT a$
    FUNCTION = 0
END FUNCTION

FUNCTION PBMAIN
    $INCLUDE "UKAW.VER"
    crlf$ = CHR$(13) + CHR$(10)
    sLogApp = "E-MAIL "
    LogOpen
    setpriorityclass 1,&h40
    s=-1
    IF commandline(Host$, Port, Helo$, Mask$) THEN GOTO endmain
    IF LEN(DIR$("WDial.No")) = 0 THEN
        PRINT "Host:"; Host$;" Port:"; Port; "HElO:"; Helo$;" File:"; Mask$
        IF connectTo(Host$, Port) THEN GOTO EndPop
        LogWrite "SMTP starting...", -1, %LogState_Routing
        IF DIR$(Mask$)="" THEN
            LogWrite "Nothing to send!", -1, %LogState_Normal
            GOTO EndMain
        END IF    
        IF login("HELO " + Helo$) THEN GOTO endpop
        SendAll mask$
        EndPop:
        IF s<> (NOT 0) THEN
            closesocket s
            LogWrite "Closed!", -1, %LogState_Normal
        END IF
        WSACleanup
    ELSE
        LogWrite sLogApp + "no actice connection!", -1, %LogState_Normal
    END IF
EndMain:
    LogClose
END FUNCTION


