'****************************************************************************
'
' UKAW Paket   : E-POP
' Version      : 1.36g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound/CrossPoint
'            or: www.basicguru.com/pbsound-hq/pbsources.win
' Last Updates : see directly in the sources
'
' all original sources by Karl-Heinz Weiss
'
'****************************************************************************

$RESOURCE "UKAW.PBR"
$INCLUDE "WIN32API.INC"
$INCLUDE "UKAW.INC"
$INCLUDE "UKAWLOG.BAS"
$INCLUDE "WSOCK32.INC"

%wsock_version= &h0101
%buflen=30000
DECLARE FUNCTION SetPriorityClass LIB "KERNEL32.DLL" ALIAS "SetPriorityClass" (BYVAL hProcess AS LONG, BYVAL dwPriorityClass AS LONG) AS LONG
DECLARE SUB Sleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS LONG)
DECLARE SUB usage()
DECLARE FUNCTION commandline(user$,pass$,host$,port%,opt$) AS INTEGER
DECLARE FUNCTION login(user$,pass$,s AS DWORD) AS INTEGER
DECLARE FUNCTION popmail(opt$,user$,host$,s AS DWORD) AS INTEGER
DECLARE FUNCTION GetMessageFromServer(rto$,i%,style%,fhdl%,s???) AS INTEGER
DECLARE FUNCTION gethdr(i%,mto$,id$,by$,s AS DWORD) AS INTEGER
DECLARE FUNCTION nextfile% (a$)
DECLARE FUNCTION parseadress$ (aa$)
DECLARE FUNCTION rewrite$(a$,aliasfile$)
DEFLNG a-z
GLOBAL rcvbuf AS STRING*%buflen
GLOBAL lpr AS DWORD,lpw AS DWORD, s AS DWORD



FUNCTION listenthread
'   DO
'     sleep 1
      IF lpr> lpw THEN
         maxtransfer = lpr - lpw-1
      ELSE
         maxtransfer = %buflen-lpw
         IF lpw+maxtransfer>=%buflen AND lpr=0 THEN
            DECR maxtransfer
         END IF
      END IF
      n=recv(s,BYVAL VARPTR(rcvbuf)+lpw,maxtransfer,0)
      IF n>0 THEN
        lpw=lpw+n
        IF lpw>=%buflen THEN
           lpw=0
        END IF
      END IF
'   LOOP
END FUNCTION

FUNCTION connectto(host$,port%)AS INTEGER
    DIM wsaData AS WSAdata
    DIM pHostEnt AS hostentStru PTR
    DIM in_addr AS in_addr
    DIM servent AS servent PTR
    DIM sockAddr AS SOCKADDR_IN
    DIM dip_addr AS ASCIIZ PTR
    DIM host_name AS ASCIIZ*64
    FUNCTION=-1
    host_name=host$
    FUNCTION=%invalid_socket
    IF WSAStartup(%wsock_version,WSAdata) THEN
        WSACleanup
        Logwrite "WSAStartup failed!", -1, %LogState_FatalError
        EXIT FUNCTION
    END IF
    Ip_adr???=inet_addr(host_name)
    IF Ip_adr??? = %INADDR_NONE THEN
        pHostEnt=gethostbyname(host_name)
        IF ISFALSE pHostEnt THEN
            WSACleanup
            Logwrite "GetHostByName failed!", -1, %LogState_FatalError
            EXIT FUNCTION
        ELSE
            in_addr.s_addr=@pHostEnt.@@h_list
            dip_addr=inet_ntoa(in_addr.s_addr)
        END IF
    ELSE
        in_addr.s_addr=Ip_adr???
    END IF
    s= socket(%PF_INET,%SOCK_STREAM,%IPPROTO_TCP)
    IF s=%INVALID_SOCKET THEN
        WSACleanup
        Logwrite "Invalid Socket!", -1, %LogState_FatalError
        EXIT FUNCTION
    END IF
    sockAddr.sin_family=%AF_INET
    sockAddr.sin_port=htons(port%)
    sockAddr.sin_addr=in_addr
    IF connect(s,sockAddr,SIZEOF(sockAddr))<>0 THEN
        WSACleanup
        Logwrite "Connection failure!", -1, %LogState_FatalError
        EXIT FUNCTION
    END IF
    cmd& = %FIONBIO
    argp& = 1
    n& = ioctlsocket( s, cmd&, argp& )
    ' /// v1.10g On, WSocket-Init mu abgeschlossen sein, ansonsten kann ///
    ' /// kann es zu Strungen in der Modacom-API kommen.
    THREAD CREATE ListenThread(s) TO hLISTEN&
    ' /// v1.00g Off ///
    FUNCTION=0
END FUNCTION

FUNCTION sendstring(a$)AS INTEGER
    u%=send(s,BYVAL STRPTR(a$),LEN(a$),0)
    IF u%=%socket_error THEN FUNCTION=-1
END FUNCTION

FUNCTION sendline(a$)AS INTEGER
   c$=a$+CHR$(13)+CHR$(10)
   FUNCTION=sendstring(c$)
END FUNCTION

FUNCTION linput(r$)AS INTEGER
  crlf$=CHR$(13)+CHR$(10)
  r$=""
  tout=5000
  DO
    listenthread
    IF lpw>lpr THEN
       r$=MID$(rcvbuf,lpr+1,lpw-lpr)
       p=INSTR(r$,crlf$)
       IF p>0 THEN
          r$=LEFT$(r$,p-1)
          lpr=lpr+p+1
          EXIT FUNCTION
       END IF
    ELSEIF lpr>lpw THEN
       r$=MID$(rcvbuf,lpr+1,%buflen-lpr)+LEFT$(rcvbuf,lpw)
       p=INSTR(r$,crlf$)
       IF p>0 THEN
          r$=LEFT$(r$,p-1)
          lpr=lpr+p+1
          IF lpr>%buflen-1 THEN lpr=lpr-%buflen
          EXIT FUNCTION
       END IF
    END IF
    sleep 10
    tout=tout-1
  LOOP
  STDOUT
  LogWrite "ERROR ON NETWORK (Timeout).", -1, %LogState_FatalError
  FUNCTION=-1
END FUNCTION

FUNCTION commandline(user$,pass$,host$,port%,opt$) AS INTEGER
    FUNCTION=-1
    cmd$=COMMAND$
    IF cmd$="" THEN
        CALL usage
        EXIT FUNCTION
        ' /// v1.10g, sieht verdammt nach Debugcode aus ;-) ///
        'cmd$="sysop:sysop@192.168.1.254, /*X-Envelope-TO:*\ -keep"
        ' /// v1.00g ///
    END IF

    ' /// v1.36g ///
    ' dummen PB-Parser abfangen und User auslesen sofern dieser eine
    ' eMail Adresse darstellt, denn leider kommen ansonsten durch das
    ' "@" alle weiteren Auswertungen durcheinander :-(

    IF LEFT$(cmd$, 1) = CHR$(34) THEN
        EmailUser$ = PARSE$(cmd$, 1)
        REPLACE EmailUser$ WITH "Dummy" IN cmd$
        REPLACE CHR$(34) WITH "" IN cmd$     ' damit der PB-Parser nicht
    ELSE                                     ' durcheinander kommt
        EmailUser$ = ""
    END IF

    ' /// v1.36g ///

    p% = PARSECOUNT(cmd$)

    IF p% > 1 THEN
        opt$ = PARSE$(cmd$, 2)
    END IF
    IF p% > 0 THEN

        host$=PARSE$(cmd$,1)
        n% = INSTR(host$,"@")

          IF n% THEN
             user$=LEFT$(host$,n%-1)
             host$=MID$(host$,n%+1)
             n%=INSTR(user$,":")
             IF n% THEN
                pass$=MID$(user$,n%+1)
                user$=LEFT$(user$,n%-1)
                p%=PARSECOUNT(host$," ")
                IF p% >1 THEN
                   port%=VAL(PARSE$(host$," ",2))
                   host$=PARSE$(host$," ",1)
                END IF
             END IF
          END IF
    END IF
    IF port%=0 THEN port%=110
    IF host$="" THEN
       LINE INPUT"Host: "host$
    END IF
    IF INSTR(host$,"?") THEN
       CALL usage
       EXIT FUNCTION
    END IF

    ' /// v1.36g ///
    IF EmailUser$ = "" THEN
    ELSE
        User$ = EmailUser$
    END IF
    ' /// v1.36g ///
    IF User$ = "" THEN
       LINE INPUT "User:" user$
    END IF

    IF pass$="" THEN
       LINE INPUT"Password:"pass$
    END IF
    IF user$="" OR pass$="" OR host$="" THEN
       CALL usage
    ELSE
       FUNCTION=0
    END IF

END FUNCTION

SUB usage
    STDOUT "E-POP " + Version$ + "                            (Freeware sources by Karl-Heinz Weiss)"
    STDOUT "                                                   compilation by " + Author$
    STDOUT " "
    'STDOUT "Usage: e-pop user:pass@host [Portnbr][,options]"
    'STDOUT "Options: [-keep] [-lf] [/[dest-dir/][file]]"
    IF DIR$("e-pop.hlp")>"" THEN
        f%=FREEFILE
        OPEN "e-pop.hlp" FOR INPUT AS #f%
    ELSE
        EXIT SUB
    END IF
    i%=0
    DO WHILE NOT EOF(f%)
       LINE input#f%,a$
       LogWrite a$, -1, %LogState_Normal
       i%=i%+1
       IF i%=21 THEN
          STDOUT SPACE$(37)+"-more- ";
          a$=WAITKEY$
          STDOUT ""
          IF LCASE$(a$)="q" THEN EXIT DO
          i%=0
       END IF
    LOOP
    CLOSE #f%
END SUB

FUNCTION sendcmd(cmd$,ack$)AS INTEGER
     FUNCTION=-1
     IF cmd$>"" THEN
        IF sendline(cmd$) THEN EXIT FUNCTION
     END IF
     IF linput(a$) THEN EXIT FUNCTION
     IF UCASE$(LEFT$(a$, LEN(ack$))) <> ack$ THEN EXIT FUNCTION
     ack$=a$
     FUNCTION=0
END FUNCTION

FUNCTION login(user$,pass$) AS INTEGER
     FUNCTION=-1
     a$="+OK"
     IF sendcmd("",a$) THEN EXIT FUNCTION
     LogWrite a$, -1, %LogState_Normal
     a$="+OK"
     IF sendcmd("USER " + user$,a$)THEN
        LogWrite "No such user!", -1, %LogState_OtherError
        EXIT FUNCTION
     END IF
     LogWrite a$, -1, %LogState_Normal
     a$="+OK"
     IF sendcmd("PASS " + pass$,a$)THEN
        LogWrite "Wrong password!", -1, %LogState_FatalError
        EXIT FUNCTION
     END IF
     LogWrite a$, -1, %LogState_Normal
     a$="+OK"
     IF sendcmd("RSET",a$) THEN EXIT FUNCTION
     LogWrite a$, -1, %LogState_Normal
     FUNCTION=0
END FUNCTION

FUNCTION parseadress$ (aa$)
     pp% = INSTR(aa$, "(")
     IF pp% THEN aa$ = LEFT$(aa$, pp% - 1)
     pp% = INSTR(aa$, "<")
     IF pp% THEN
       aa$ = MID$(aa$, pp% + 1)
       pp% = INSTR(aa$, ">")
       IF pp% THEN aa$ = LEFT$(aa$, pp% - 1)
     END IF
     FUNCTION= LTRIM$(RTRIM$(aa$))
END FUNCTION

FUNCTION GetMessageFromServer(rto$,i%,style%,fhdl%) AS INTEGER
      '/// v1.21g, Funktionsname gendert da in Konflikt mit Win32API ///
      FUNCTION=-1
      crlf$=CHR$(13)+CHR$(10)
      IF (style% AND 1) THEN crlf$=CHR$(10)
      IF sendcmd("RETR"+STR$(i%),a$) THEN EXIT FUNCTION
      bcnt???=0
      DO
         IF linput(a$) THEN EXIT FUNCTION
         IF a$="" THEN hdr%=-1
         qf%=INSTR(a$,"From ")
         IF hdr%=0 THEN
            IF LEN(rto$)>0 AND INSTR(a$,"To: ")=1 THEN
               a$="X-Original-To:"+MID$(a$,4)
               a$="To: "+rto$+crlf$+a$
            END IF
            IF qf%<>1 THEN PRINT #fhdl%,a$;crlf$;
         ELSE
            IF (style% AND 2) AND (qf%=1) THEN a$=">"+a$
            IF a$<>"." THEN PRINT #fhdl%,a$;crlf$;
         END IF
         bcnt???=bcnt???+LEN(a$)+2
         IF bcnt???>=1000 THEN
            bcnt1???=bcnt1???+bcnt???
            bcnt???=0
            LOCATE ,1
            PRINT bcnt1???;
         END IF
      LOOP WHILE a$<>"."
      FUNCTION=0
END FUNCTION

FUNCTION gethdr(i%,mto$,id$,by$) AS INTEGER
   FUNCTION=-1
   by$=""
   adr$=mto$
   mto$=""
   a$=""
   IF sendcmd("TOP"+STR$(i%)+" 0",a$) THEN EXIT FUNCTION
   IF linput(aa$) THEN EXIT FUNCTION
   DO
      a$=aa$
      IF a$="." THEN FUNCTION=0:EXIT FUNCTION
      DO
        IF linput(aa$) THEN EXIT FUNCTION
        a%=INSTR(CHR$(9)+" ",LEFT$(aa$,1))
        IF a% THEN
           REPLACE CHR$(9) WITH " " IN aa$
           a$=a$+aa$
        END IF
      LOOP WHILE a%
      IF by$="" THEN
         p%=INSTR(UCASE$(a$),"RECEIVED: ")
         IF p%=1 THEN p%=INSTR(10,a$," by ")
         IF p% THEN
            by$=LTRIM$(MID$(a$,p%+4))
            by$=EXTRACT$(by$," ")
            a$=""
         END IF
      END IF
      IF LEN(mto$)=0 THEN
         IF UCASE$(LEFT$(a$,LEN(adr$)))=UCASE$(adr$) THEN
            mto$=parseadress$(MID$(a$,LEN(adr$)+1))
            mto$=EXTRACT$(mto$,"@")
         END IF
      END IF
      IF LEN(mi$)=0 AND LEN(id$)>0 THEN
         IF UCASE$(LEFT$(a$,LEN(id$)))=UCASE$(id$) THEN
            mi$=MID$(a$,LEN(id$)+1)
            id$=mi$
         END IF
      END IF
   LOOP WHILE a$<>"."
   FUNCTION=0
END FUNCTION

FUNCTION nextfile% (a$)
wild% = INSTR(a$, "?")
count%=TALLY(a$,"?")
f$ = DIR$(a$)
wild%=wild%-(LEN(a$)-LEN(f$))
DO WHILE LEN(f$)
   nbr% = VAL(MID$(f$, wild%,count%))
   IF nbr% > nbr0% THEN nbr0% = nbr%
   f$ = DIR$
LOOP
FUNCTION= nbr0%
END FUNCTION

FUNCTION rewrite$(a$,aliasfile$)
   IF LEN(aliasfile$)<2 THEN
      FUNCTION=a$
      EXIT FUNCTION
   END IF
   crlf$=CHR$(13)+CHR$(10)
   p0%=1
   DO
     p1%=INSTR(p0%,aliasfile$,crlf$)
     b$=MID$(aliasfile$,p0%,p1%-p0%)
     IF LEN(b$) THEN
        c$=PARSE$(b$," ",1)
        IF UCASE$(c$)=UCASE$(a$) THEN
           c$=TRIM$(PARSE$(b$," ",2))
           IF c$>"" THEN
              FUNCTION=c$
              EXIT FUNCTION
           END IF
        END IF
     END IF
     p0%=p1%+LEN(crlf$)
   LOOP WHILE p0%<LEN(aliasfile$)
   FUNCTION=""
END FUNCTION

FUNCTION testid%(id$,msgid$,pc%,newid$,keep%)
   FUNCTION=-1
   IF keep%<>0 AND id$>"" THEN newid$=newid$+id$+CHR$(10)
   FOR i%=1 TO pc%
       IF id$=PARSE$(msgid$,CHR$(10),i%)THEN
          FUNCTION=0
          EXIT FUNCTION
       END IF
   NEXT
END FUNCTION

FUNCTION popmail(opt$,user$,host$) AS INTEGER
   FUNCTION=-1
   IF UCASE$(DIR$("rewrite"))="REWRITE" THEN
      f%=FREEFILE
      OPEN "rewrite" FOR BINARY AS f%
      GET$ #f%,LOF(f%),aliasfile$
      CLOSE #f%
   END IF
   OPEN "e-pop.idx" FOR BINARY AS f%
   GET$ #f%,LOF(f%),msgid$
   CLOSE f%
   pc%=PARSECOUNT(msgid$,CHR$(10))-1
   style%=2
   a$="+OK"
   IF sendcmd("STAT",a$) THEN EXIT FUNCTION
   LogWrite a$, -1, %LogState_Normal
   maxmsg%=VAL(PARSE$(a$," ",2))
   o$=opt$
   p%=INSTR(LCASE$(o$),"-r")
   IF p%>0 THEN
      rto$=PARSE$(MID$(o$,p%)," ",2)
      IF INSTR(LTRIM$(rto$),ANY"-/\.:")<>1 THEN
         o$=LEFT$(o$,p%-1)+MID$(o$,p%+3+LEN(rto$))
      ELSE
         rto$=""
      END IF
      IF rto$="" THEN rto$=user$+"@"+host$
      rto$=TRIM$(rto$)
   END IF
   p%=INSTR(o$, ANY "/\.:")
   IF p% THEN
      IF MID$(o$,p%,1)=":" THEN
         p%=p%-2
      ELSEIF MID$(o$,p%,1)<>"/" THEN
         DECR p%
      END IF
      path$=TRIM$(EXTRACT$(p%+1,o$," "))
      IF p%=0 THEN p%=1
      o$=LEFT$(o$,p%-1)+MID$(o$,p%+LEN(path$)+1)
   END IF
   IF path$="" THEN
      path$=".\spool\m????.msg"
      IF DIR$(".\spool",16)="" THEN MKDIR ".\spool"
      IF DIR$(".\spool",16)="" THEN
         PRINT ".\spool doesn't exist!"
         EXIT FUNCTION
      END IF
   END IF
   IF RIGHT$(path$,1)="\" THEN path$=path$+"in.mbx"
   IF INSTR(UCASE$(o$),"-KEEP") THEN keep%=-1
   p%=PARSECOUNT(path$,"*")
   IF p%=3 THEN
      xenv$=UCASE$(PARSE$(path$,"*",2))
      IF xenv$="USER" THEN
         xenv$=""
         path$=PARSE$(path$,"*",1)+user$+PARSE$(path$,"*",3)
         p%=1
      END IF
   END IF
   isnbr%= TALLY(path$,"?")
   IF isnbr% THEN
      p1%=INSTR(path$,"?")
      startnbr%=nextfile%(path$)
      style%=0
   END IF
   IF INSTR(UCASE$(o$),"-CRLF")THEN
      crlf$=CHR$(13)+CHR$(10)
   ELSE
      INCR style%
      crlf$=CHR$(10)
   END IF
   FOR i%=1 TO maxmsg%
      IF isnbr% THEN
         INCR startnbr%
         nbr$=STRING$(isnbr%,"0")+LTRIM$(STR$(startnbr%))
         MID$(path$,p1%)=RIGHT$(nbr$,isnbr%)
      END IF
      IF xenv$="" THEN
         mto$="To: "
      ELSE
         mto$=xenv$+" "
      END IF
      id$="Message-Id: "
      IF gethdr(i%,mto$,id$,by$)THEN EXIT FUNCTION
      STDOUT "        To:"+mto$+" ";
      IF p%=3 THEN
         IF LEN(xenv$) THEN
            mto$=rewrite$(mto$,aliasfile$)
         END IF
         IF mto$="" THEN mto$="."
         mto$=PARSE$(path$,"*",1)+mto$+PARSE$(path$,"*",3)
      ELSE
         mto$=path$
      END IF
      FOR j%=LEN(mto$)TO 1 STEP -1
          IF VERIFY (MID$(mto$,j%,1),":\ ")=0 THEN EXIT FOR
      NEXT
      IF j%>0 THEN
         IF (GETATTR(LEFT$(mto$,j%-1)) AND 16)=0 THEN
            FOR j%=j%-1 TO 1 STEP -1
                IF VERIFY (MID$(mto$,j%,1),":\ ")=0 THEN EXIT FOR
            NEXT
            mto$=LEFT$(mto$,j%)+"sysop"
            MKDIR mto$
            mto$=mto$+"\in.mbx"
         END IF
      END IF
      IF testid%(id$,msgid$,pc%,newid$,keep%) THEN
         fhdl%=FREEFILE
         STDOUT "Maildrop: '"+mto$+"'";
         OPEN mto$ FOR APPEND AS fhdl%
         PRINT #fhdl%,"From e-pop@localhost Sun Jan";crlf$;
         PRINT #fhdl%,"Received: from ";by$;" by localhost (E-pop) with POP3";crlf$;
         st%= GetMessageFromServer(rto$,i%,style%,fhdl%)
         STDOUT ""
         CLOSE fhdl%
         IF st% THEN EXIT FUNCTION
      ELSE
         STDOUT ""
      END IF
      IF keep%=0 THEN
         a$="+OK"
         st%=sendcmd("DELE"+STR$(i%),a$)
         LogWrite a$, -1, %LogState_Normal
      END IF
   NEXT
   f%=FREEFILE
   KILL "e-pop.idx"
   OPEN "e-pop.idx" FOR BINARY AS f%
   PUT$ f%,newid$
   CLOSE f%
   ack$="+OK"
   IF sendcmd("QUIT",ack$)THEN EXIT FUNCTION
   FUNCTION=0
END FUNCTION

FUNCTION PBMAIN()
    $INCLUDE "UKAW.VER"
    sLogApp = "E-POP  "
    setpriorityclass 1,&h40
    DIM s AS DWORD
    s=-1
    IF commandline(user$, pass$, host$, port%, opt$) THEN GOTO endmain
    LogOpen
    IF LEN(DIR$("WDial.No")) = 0 THEN
        LogWrite "Optionen: " + opt$, -1, %LogState_Normal
        IF connectTo(host$,port%) THEN GOTO endpop
        LogWrite "POP3 starting...", -1, %LogState_Routing
        IF login(user$,pass$) THEN GOTO endpop
        popmail opt$,user$,host$
        endpop:
        IF s<> (NOT 0) THEN
            closesocket s
            LogWrite "Closed!", -1, %LogState_Normal
        END IF
        WSACleanup
    ELSE
        LogWrite sLogApp + "no actice connection!", -1, %LogState_Normal
    END IF
endmain:
    LogClose
END FUNCTION
