'****************************************************************************
'
' UKAW Paket   : E-NEWS
' Version      : 1.31g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound/CrossPoint
'            or: www.basicguru.com/pbsound-hq/pbsources.win
' Last Updates : see directly in the sources
'
' all original sources by Karl-Heinz Weiss
'
'****************************************************************************

DEFLNG A-Z

$RESOURCE "UKAW.PBR"
$INCLUDE "WIN32API.INC"
$INCLUDE "WSOCK32.INC"
$INCLUDE "UKAW.INC"
$INCLUDE "UKAWLOG.BAS"

TYPE SMALL_RECT
  xLeft   AS INTEGER
  xTop    AS INTEGER
  xRight  AS INTEGER
  xBottom AS INTEGER
END TYPE
DECLARE FUNCTION SetConsoleTitle LIB "KERNEL32.DLL" ALIAS "SetConsoleTitleA" (lpConsoleTitle AS ASCIIZ) AS LONG
DECLARE FUNCTION SetPriorityClass LIB "KERNEL32.DLL" ALIAS "SetPriorityClass" (BYVAL hProcess AS LONG, BYVAL dwPriorityClass AS LONG) AS LONG
DECLARE FUNCTION GetPriorityClass LIB "KERNEL32.DLL" ALIAS "GetPriorityClass" (BYVAL hProcess AS LONG) AS LONG
' /// v1.21g, bereits in Win32API deklariert
'DECLARE FUNCTION SetConsoleScreenBufferSize LIB "KERNEL32.DLL" ALIAS "SetConsoleScreenBufferSize" (BYVAL hConsoleOutput AS LONG, BYVAL dwSize AS LONG) AS LONG
'DECLARE FUNCTION SetConsoleWindowInfo LIB "KERNEL32.DLL" ALIAS "SetConsoleWindowInfo" (BYVAL hConsoleOutput AS LONG, BYVAL bAbsolute AS LONG, lpConsoleWindow AS SMALL_RECT) AS LONG
' /// v1.21g
DECLARE SUB Sleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS LONG)
DECLARE FUNCTION GetCommandLine LIB "KERNEL32.DLL" ALIAS "GetCommandLineA" () AS DWORD

%wsock_version= &h0101
%buflen=5000
GLOBAL lpr()AS DWORD,lpw()AS DWORD,rcvbuf()AS STRING*%buflen,hs() AS DWORD
GLOBAL crlf$,spool$,config$(),teststring$,testlong AS LONG, hThread() AS LONG
GLOBAL total() AS LONG,locknext AS LONG,month$()

'/// v1.10g ///
GLOBAL TimeOut AS INTEGER, MultiGet AS INTEGER
'/// v1.10g ///

FUNCTION ListenThread(BYVAL h AS LONG) AS LONG
   DO
      IF lpr(h)> lpw(h) THEN
         maxtransfer = lpr(h) - lpw(h)-1
      ELSE
         maxtransfer = %buflen-lpw(h)
         IF lpw(h)+maxtransfer>=%buflen AND lpr(h)=0 THEN
            DECR maxtransfer
         END IF
      END IF
      n=recv(hs(h),BYVAL(VARPTR(rcvbuf(h))+lpw(h)),maxtransfer,0)
      IF n>0 THEN
        total(h)=total(h)+n
        IF lpw(h)+n>=%buflen THEN
           lpw(h)=0
        ELSE
           lpw(h)=lpw(h)+n
        END IF
      END IF
   LOOP
END FUNCTION

FUNCTION connectto(host$,port%,h)AS INTEGER
    DIM wsaData AS WSAdata
    DIM pHostEnt AS hostentStru PTR
    DIM in_addr AS in_addr
    DIM servent AS servent PTR
    DIM sockAddr AS SOCKADDR_IN
    DIM dip_addr AS ASCIIZ PTR
    DIM host_name AS ASCIIZ*64

    FUNCTION=-1
    host_name=host$
    FUNCTION=%invalid_socket
    IF WSAStartup(%wsock_version,WSAdata) THEN
        WSACleanup
        Logwrite "WSAStartup failed!", h, %LogState_FatalError
        EXIT FUNCTION
    END IF
    Ip_adr???=inet_addr(host_name)
    IF Ip_adr??? = %INADDR_NONE THEN
        pHostEnt=gethostbyname(host_name)
        IF ISFALSE pHostEnt THEN
            WSACleanup
            Logwrite "GetHostByName failed!", h, %LogState_FatalError
            EXIT FUNCTION
        ELSE
            in_addr.s_addr=@pHostEnt.@@h_list
            dip_addr=inet_ntoa(in_addr.s_addr)
        END IF
    ELSE
        in_addr.s_addr=IP_adr???
    END IF
    s= socket(%PF_INET,%SOCK_STREAM,%IPPROTO_TCP)
    IF s=%INVALID_SOCKET THEN
        WSACleanup
        Logwrite "Invalid Socket!", h, %LogState_FatalError
        EXIT FUNCTION
    END IF
    sockAddr.sin_family=%AF_INET
    sockAddr.sin_port=htons(port%)
    sockAddr.sin_addr=in_addr
    IF connect(s,sockAddr,SIZEOF(sockAddr))=0 THEN
    ELSE
       WSACleanup
       Logwrite "Connection failure!", h, %LogState_FatalError
       EXIT FUNCTION
    END IF
    cmd& = %FIONBIO
    argp& = 1
'    n& = ioctlsocket( s, cmd&, argp& )
    hs(h)=s
    THREAD CREATE ListenThread(h) TO hLISTEN&
    FUNCTION=0
END FUNCTION

FUNCTION sendstring(a$,h)AS INTEGER
    u%=send(hs(h),BYVAL STRPTR(a$),LEN(a$),0)
    IF u%=%socket_error THEN FUNCTION=-1
END FUNCTION

FUNCTION sendline(a$,h)AS INTEGER
   c$=a$+CHR$(13)+CHR$(10)
   FUNCTION=sendstring(c$,h)
END FUNCTION

FUNCTION linput(r$,h)AS INTEGER
    r$=""
    tout=5000
    DO
        IF lpw(h)>lpr(h) THEN
            r$=MID$(rcvbuf(h),lpr(h)+1,lpw(h)-lpr(h))
            p=INSTR(r$,crlf$)
            IF p>0 THEN
                r$=LEFT$(r$,p-1)
                lpr(h)=lpr(h)+p+1
                EXIT FUNCTION
            END IF
        ELSEIF lpr(h)>lpw(h) THEN
            r$=MID$(rcvbuf(h),lpr(h)+1,%buflen-lpr(h))+LEFT$(rcvbuf(h),lpw(h))
            p=INSTR(r$,crlf$)
            IF p>0 THEN
                r$=LEFT$(r$,p-1)
                lpr(h)=lpr(h)+p+1
                IF lpr(h)>%buflen-1 THEN lpr(h)=lpr(h)-%buflen
                EXIT FUNCTION
            END IF
        END IF
        sleep 10
        tout=tout-1
    LOOP WHILE tout>=0 AND INKEY$<>CHR$(27)
    STDOUT
    IF tout<0 THEN
        LogWrite "(ERROR ON NETWORK (Timeout).", h, %LogState_FatalError
    ELSE
        Logwrite "Aborted by user.", h, %LogState_OtherError
    END IF
    FUNCTION=-1
END FUNCTION

FUNCTION check$(rc$,match$,default$)
   p=INSTR(rc$,crlf$+match$)
   IF p=0 THEN
      a$=default$
   ELSE
      a$=LTRIM$(EXTRACT$(p+2+LEN(match$),rc$,crlf$))
      IF LEFT$(a$,1)=CHR$(34) THEN
         p=INSTR(2,a$,CHR$(34))
         IF p=0 THEN p=LEN(a$)+1
         a$=MID$(a$,2,p-2)
      ELSE
         p=INSTR(a$,ANY " "+CHR$(35))
         IF p =0 THEN p=LEN(a$)+1
         a$=LEFT$(a$,p-1)
      END IF
   IF a$="" THEN a$=default$
   END IF
   FUNCTION=a$
END FUNCTION

FUNCTION CommandLine(User$, Pass$, Host$, Nl$, List$, Port%, h) AS INTEGER
    FUNCTION = -1
    fl = FREEFILE
    OPEN Config$(h) FOR BINARY AS fl
    GET$ fl, LOF(fl), Rc$
    CLOSE fl
    ' /// v1.31g ///
    ' Bedingt dadurch das einige Newsserver Gro- und Kleinschreibung bei
    ' den User- und Pawrtern verlangen, wurde die Routine komplett umge-
    ' schrieben. Das umwandeln des RC-Strings erfolgt nun direkt bei jedem
    ' Parser-Aufruf und nicht mehr global fr User$/Pass$
    ' /// End    ///
    Rc$ = crlf$ + Rc$
    nl$ = Check$(LCASE$(Rc$), "$newline:", "crlf")
    SELECT CASE nl$
           CASE "crlf"
                nl$ = crlf$
           CASE "lf"
                nl$ = CHR$(10)
           CASE ELSE
                LogWrite "Syntax error in " + Config$(h) +"." , h, %LogState_OtherError
                LogWrite "$newline: Only 'lf' OR 'crlf' allowed!" , h, %LogState_OtherError
                EXIT FUNCTION
    END SELECT
    List$    = Check$(LCASE$(Rc$), "$list:", "LIST")
    Host$    = Check$(LCASE$(Rc$), "$server:", "")
    User$    = Check$(Rc$, "$user:", "")
    Pass$    = Check$(Rc$, "$pass:", "")
    Multiget = VAL(check$(LCASE$(Rc$), "$multiget:", "5"))
    Timeout  = 100 * VAL(check$(LCASE$(Rc$), "$timeout:", "60"))
    Spool$   = Check$(LCASE$(Rc$),"$spool:",".\spool")
    IF DIR$(Spool$, 16) = "" THEN MKDIR Spool$
    IF DIR$(Spool$, 16) = "" THEN
        LogWrite Spool$ + " doesn't exist!" , h, %LogState_OtherError
        EXIT FUNCTION
    END IF
    Port%    = VAL(check$(LCASE$(Rc$),"$port:","119"))
    IF Host$ = "" THEN
       LogWrite "No Host!", h, %LogState_OtherError
    END IF
    FUNCTION = 0
END FUNCTION

FUNCTION Nextfile(h)
    DO:LOOP WHILE locknext>0
    INCR locknext
    DO:LOOP WHILE locknext<>1
    a$=spool$+"\n"+LTRIM$(STR$(h))+"???.msg"
    f$ = DIR$(a$)
    DO WHILE LEN(f$)
       nbr% = VAL(MID$(f$,LEN(f$)-6,4))
       IF nbr% > nbr0% THEN nbr0% = nbr%
       f$ = DIR$
    LOOP
    DECR locknext
    nextfile=nbr0%+1
    'nextfile$="n"+RIGHT$("0000"+TRIM$(STR$(nbr0%)),4)+".in"
END FUNCTION

FUNCTION GetMsg(fl$, fln, nl$, h)
   fl=FREEFILE
   OPEN fl$ FOR BINARY AS fl
   s0=LOF(fl)+1
   SEEK fl,s0
   IF fln=0 THEN
      hdr$=SPACE$(30-LEN(nl$))+nl$
      PUT$ fl,hdr$
   END IF
   DO
      IF linput(r$,h) < 0 THEN
         SEEK fl,s0
         SETEOF fl
         CLOSE fl
         FUNCTION=-1
         EXIT FUNCTION
      END IF
      REPLACE CHR$(9) WITH " " IN r$
      IF r$="."THEN
         LOCATE ,1
         STDOUT STR$(n)
         IF fln=0 THEN
           'rnews-header
           MID$(hdr$, 1) = "#! rnews" + STR$(n)
           SEEK fl,s0
           PUT$ fl,hdr$
         END IF
         CLOSE fl
         FUNCTION=n
         EXIT FUNCTION
      ELSE
         IF LEFT$(r$,2)=".." THEN r$=MID$(r$,2)
         r$=r$+nl$
         n=n+LEN(r$)
         n0=n0+LEN(r$)
         PUT$ fl,r$
         IF n0>=1000 THEN
            LOCATE ,1
            STDOUT STR$(n);
            n0=0
         END IF
      END IF
   LOOP
END FUNCTION

FUNCTION response(a$)
   FUNCTION=VAL(LEFT$(a$,3))
END FUNCTION

FUNCTION sendcmd(cmd$,ack$,h)AS INTEGER
     FUNCTION=-1
     IF cmd$>"" THEN
        IF sendline(cmd$,h) THEN EXIT FUNCTION
     END IF
     IF linput(a$,h) THEN EXIT FUNCTION
     ack$=a$
     FUNCTION=0
END FUNCTION

FUNCTION login(user$,pass$,h) AS INTEGER
     FUNCTION=-1
     IF linput(a$,h) THEN EXIT FUNCTION
     LogWrite a$, h, %LogState_Normal
     rsp= response(a$)
     IF (rsp=200 OR rsp=201) AND pass$>"" THEN
        Logwrite "AUTHINFO " + user$, h, %LogState_Normal
        IF sendcmd("AUTHINFO USER "+user$,ack$,h) THEN EXIT FUNCTION
        IF response(ack$)<>381 THEN EXIT FUNCTION
        IF sendcmd("AUTHINFO PASS "+pass$,ack$,h) THEN EXIT FUNCTION
        IF response(ack$)<>281 THEN EXIT FUNCTION
     END IF
     FUNCTION=rsp
END FUNCTION

FUNCTION postnews(h)
   FUNCTION=-1
   DO:LOOP WHILE locknext>0
   INCR locknext
   DO:LOOP WHILE locknext<>1
   postings$=""
   f$=DIR$(spool$+"\n????.out")
   DO WHILE LEN(f$)>0
      p=p+1
      postings$=postings$+f$+","
      f$=DIR$
   LOOP
   DECR locknext
   FOR i=1 TO p
      f$=PARSE$(postings$,i)
      IF f$="" THEN EXIT FUNCTION
      IF sendcmd("POST",ack$,h)THEN EXIT FUNCTION
      STDOUT ack$
      IF LEFT$(ack$,1)<>"3" THEN EXIT FUNCTION
      LogWrite "Posting " + f$, h, %LogState_FileNames
      f=FREEFILE
      OPEN spool$+"\"+f$ FOR BINARY AS f
      GET$ f,LOF(f),buf$
      CLOSE f
      IF INSTR(buf$,crlf$)=0 THEN
         REPLACE CHR$(10) WITH crlf$ IN buf$
      END IF
      REPLACE CHR$(10)+"." WITH CHR$(10)+".." IN buf$
      IF RIGHT$(buf$,2)<>crlf$ THEN buf$=buf$+crlf$
      buf$=buf$+"."+crlf$
      l=send (hs(h),BYVAL STRPTR(buf$),LEN(buf$),0)
      IF l<>LEN(buf$) THEN EXIT FUNCTION
      IF linput(a$,h) THEN EXIT FUNCTION
      LogWrite a$, h, %LogState_Normal
      IF response(a$) =240 THEN KILL spool$+"\"+f$
   NEXT
   FUNCTION=0
END FUNCTION

FUNCTION getlist(fnbr,nl$,list$,h)
   FUNCTION=-1
   'Current Date Time
   a$ = DATE$
   n$ = RIGHT$(a$, 2) + LEFT$(a$, 2) + MID$(a$, 4, 2)
   a$ = TIME$
   n$ = n$ + " " + LEFT$(a$, 2) + MID$(a$, 4, 2) + RIGHT$(a$, 2)
   FOR i=LEN(config$(h)) TO 1 STEP -1
       IF INSTR(i,config$(h),ANY ":\")>0 THEN EXIT FOR
   NEXT
   path$=LEFT$(config$(h),i)
   fl$=MID$(config$(h),i+1)
   fl$=path$+EXTRACT$(fl$,".")+".gr"
   IF fl$=config$(h) THEN fl$=fl$+"1"
   fl=FREEFILE
   IF DIR$(fl$)="" THEN
      LogWrite "Creating list of newsgroups.", h, %LogState_Normal
      LogWrite "Sending: "+list$, h, %LogState_Normal
      OPEN fl$ FOR BINARY AS fl
      PUT$ #fl,"!new_groups:"+n$+nl$
      CLOSE fl
      IF sendcmd(list$,ack$,h) THEN EXIT FUNCTION
      LogWrite "Creating Groupslist " + fl$, h, %LogState_Normal
      STDOUT "         "+ack$;
      IF response(ack$)=215 THEN
         IF getmsg(fl$,-1,crlf$,h)<0 THEN EXIT FUNCTION
      END IF
   ELSE
      OPEN fl$ FOR BINARY AS fl
      lfl=LOF(fl)
      GET$ fl,256,d$
      CLOSE fl
      d$=EXTRACT$(d$,crlf$)
      p=INSTR(d$,":")
      IF LCASE$(LEFT$(d$,p))<>"!new_groups:" THEN
         LogWrite "Missing label '!new_groups:' in first line of file '"+fl$+"'", h, %LogState_OtherError
         FUNCTION=0
         EXIT FUNCTION
      END IF
      od$=TRIM$(MID$(d$,p+1))
      a$ = "newgroups " + od$
      LogWrite "Updating list of newsgroups.", h, %LogState_Normal
      LogWrite "Sending: " + a$, h, %LogState_Normal
      IF sendcmd%(a$,ack$,h) THEN EXIT FUNCTION
      STDOUT "         "+ack$;
      IF response(ack$)=231 THEN
         IF getmsg(fl$,-1,crlf$,h)<0 THEN EXIT FUNCTION
         MID$(d$,1)=SPACE$(LEN(d$))
         MID$(d$,1)="!new_groups:"+n$
         OPEN fl$ FOR BINARY AS fl
         PUT$ fl,d$
         IF LOF(fl)>lfl THEN
            SEEK fl,lfl+1
            GET$ fl,LOF(fl)-lfl,newnews$
            CLOSE fl
            a$="Path: local"+nl$
            a$=a$+"Newsgroups: local.e-news"+nl$
            aa$=TRIM$(STR$(TIMER))+DATE$+"@local.e-news"
            a$=a$+"Message-ID: <"+aa$+">"+nl$
            a$=a$+"From: e-news"+crlf$+"Subject: ("+config$(h)+") New Newsgroups available!"+nl$
            m=VAL(MID$(DATE$,1,2))
            t=VAL(MID$(DATE$,4,2))
            y$=MID$(DATE$,7,4)
            a$=a$+"Date:"+STR$(t)+" "+month$(m)+" "+y$+" "+TIME$+nl$+nl$
            a$=a$+newnews$
            a$="#! rnews" + STR$(LEN(a$))+nl$+a$
            art$=spool$+"\n"+LTRIM$(STR$(h))+RIGHT$("0000"+TRIM$(STR$(fnbr)),3)+".msg"
            fl=FREEFILE
            OPEN art$ FOR BINARY AS fl
            PUT$ fl,a$
            CLOSE fl
         ELSE
            CLOSE fl
         END IF
      END IF
   END IF
   FUNCTION=0
END FUNCTION

FUNCTION readarts(ng$,fnbr,nl$,h)

    ' /// v1.10g STATIC-Anweisung entbndelt, da Kompilierungsfehler
    STATIC rescan$
    STATIC id$
    STATIC lhdr AS LONG
    STATIC max_len AS LONG
    ' /// v1.10g ///

    IF LEFT$(ng$, 1) = "$" THEN
      IF LCASE$(LEFT$(ng$, 9)) = "$max_len:" THEN
         max_len = VAL(MID$(ng$, 10))
      ELSEIF LCASE$(LEFT$(ng$, 8)) = "$rescan:" THEN
         rescan$ = TRIM$(MID$(ng$, 9))
         rescan$ = EXTRACT$(rescan$, "#")
         ng$ = "$rescan:"
      ELSEIF LCASE$(LEFT$(ng$, 6)) = "$lhdr:" THEN
         lhdr = VAL(MID$(ng$, 7))
         ' /// v1.28g ///
         IF lhdr = 2 THEN
             ng$ = "$lhdr:2"
         ELSE
             ng$ = "$lhdr:0"
         END IF
         ' /// v1.28g ///
      END IF
      EXIT FUNCTION
   END IF
   FUNCTION=-1
   group$=EXTRACT$(ng$," ")
   IF sendcmd("GROUP "+group$,ack$,h) THEN EXIT FUNCTION
   LogWrite "Scanning: "+PARSE$(ack$," ",5), h, %LogState_BriefMsg
   IF VAL(PARSE$(ack$," ",1))<>211 THEN
       LogWrite ack$, h, %LogState_OtherError
       FUNCTION = 0
       EXIT FUNCTION
   END IF
   nbr0=0
   p=INSTR(ng$," ")
   IF p THEN nbr0=VAL(MID$(ng$,p))
   p=PARSECOUNT(ack$," ")
   IF p<4 THEN EXIT FUNCTION
   first=VAL(PARSE$(ack$," ",3))
   last=VAL(PARSE$(ack$," ",4))
   IF rescan$>"" THEN nbr0=VAL(rescan$)
   IF nbr0>0 THEN
     IF rescan$>"" THEN DECR nbr0
     IF nbr0>=first THEN first=nbr0+1
   ELSEIF nbr0<0 THEN
      IF first<=last+nbr0+1 THEN first=last+nbr0+1
   ELSE
      ng$=EXTRACT$(ng$," ")+STR$(last)
      FUNCTION=0
      EXIT FUNCTION
   END IF
   DO
     IF sendcmd("STAT"+STR$(first),ack$,h) THEN EXIT FUNCTION
     rsp=VAL(EXTRACT$(ack$," "))
     IF rsp=423 OR rsp=430 THEN
        IF first<last THEN
           INCR first
        ELSE
           FUNCTION=0
           ng$=EXTRACT$(ng$," ")+STR$(last)
           rsp=421
        END IF
     END IF
   LOOP WHILE rsp=423 OR rsp=430
   IF rsp<>223 THEN EXIT FUNCTION
   a$="XOVER"+STR$(first)+"-"+LTRIM$(STR$(last))
   IF sendcmd(a$,ack$,h)THEN EXIT FUNCTION
   IF VAL(EXTRACT$(ack$," "))<>224 THEN EXIT FUNCTION
   STDOUT "          "+a$;
   lines=0
   IF max_len <1 THEN max_len=9999999
   art$=spool$+"\n"+LTRIM$(STR$(h))+RIGHT$("0000"+TRIM$(STR$(fnbr)),3)+".msg"
   IF fnbr = 999 THEN
       LogWrite "Too many Newsgroups!", h, %LogState_OtherError
       EXIT FUNCTION
   END IF    
   fnbr=fnbr+1
   IF lhdr<>0 THEN
      fl=FREEFILE
      OPEN art$ FOR BINARY AS fl
      a$= SPACE$(30)+nl$
      a$=a$+"Path: local"+nl$
      a$=a$+"Newsgroups: "+EXTRACT$(ng$," ")+nl$
      aa$=TRIM$(STR$(TIMER))+DATE$+"@e-news.local"
      REPLACE "," WITH"." IN aa$
      a$=a$+"Message-ID: <"+aa$+">"+nl$
      a$=a$+"From: e-news"+crlf$+"Subject: $lhdr"+nl$
      m=VAL(MID$(DATE$,1,2))
      t=VAL(MID$(DATE$,4,2))
      y$=MID$(DATE$,7,4)
      a$=a$+"Date:"+STR$(t)+" "+month$(m)+" "+y$+" "+TIME$+nl$+nl$
      PUT$ fl,a$
   END IF
   DO
      IF linput(a$,h)<0 THEN
         IF lhdr<>0 THEN
            SEEK fl,1
            a$="#! rnews" + STR$(lmsg)
            PUT$ fl,a$
            CLOSE fl
            IF last$>"" THEN
               ng$=EXTRACT$(ng$," ")+" "+last$
            END IF
         END IF
         EXIT FUNCTION
      END IF
      IF a$<>"." THEN
         last$=PARSE$(a$,CHR$(9),1)
         IF lhdr<>0 THEN
            lmsg=lmsg+LEN(a$)+LEN(nl$)
            PUT$ fl,a$+nl$
         END IF
         i$=PARSE$(a$,CHR$(9),5)
         teststring$=i$
         IF INSTR(id$,i$)=0 AND VAL(PARSE$(a$,CHR$(9),7))<max_len THEN
            id$=id$+i$+crlf$
            teststring$=id$
            lines=lines+1
            anbr$=anbr$+last$+crlf$
         ELSE
            dupes=dupes+1
         END IF
      END IF
      IF (lines MOD 10)=0 THEN
          LOCATE,1
          PRINT lines;
      END IF
   LOOP WHILE a$<>"."
   IF lhdr<>0 THEN
      SEEK fl,1
      a$="#! rnews"+STR$(lmsg)
      PUT$ fl, a$
      CLOSE fl
      IF last$>"" THEN
         ng$=EXTRACT$(ng$," ")+" "+last$
      END IF
      PRINT
      EXIT FUNCTION
   END IF
   LOCATE,1
   LogWrite LTRIM$(STR$(lines))+"/"+LTRIM$(STR$(dupes)), h, %LogState_Normal
   IF lines=0 THEN
      FUNCTION=0
      ng$=EXTRACT$(ng$," ")+STR$(last)
      EXIT FUNCTION
   END IF
      n=lines
      articlecount=n
      push = 0
      n=0
      DO WHILE push < articlecount AND push < multiget
          a$ = "ARTICLE " +PARSE$(anbr$,crlf$,push+1)
          IF sendline(a$,h)<0 THEN EXIT FUNCTION
          INCR push
          INCR n
      LOOP
      DECR n
      DO
         IF linput(ack$,h)<0 THEN EXIT FUNCTION
         b$=SPACE$(60)
         st& =VAL(EXTRACT$(ack$," "))  'Status Response
         a$=PARSE$(ack$," ",3)          'MSGID
         IF st& >= 400 THEN    'server problem, e.g. article missing
            LogWrite "Unexpected: " + STR$(st&) + ack$, h, %LogState_OtherError
            DECR push
            articlecount = articlecount - 1
         END IF
         IF st& = 220 THEN
            anr$=PARSE$(anbr$,crlf$,n-push+2)
            MID$(b$, 1) = a$      'Current ID
            LOCATE , 11
            p = INSTR(b$, ">"): IF p = 0 THEN p = LEN(b$)
            PRINT LEFT$(b$, p);
            lmsg= getmsg(art$,fl,nl$,h)
            IF lmsg<0 THEN EXIT FUNCTION
            ng$=EXTRACT$(ng$," ")+" " +anr$
            DECR articlecount
            DECR push
         END IF
         IF st& = 220 OR st& >= 400 THEN
            IF articlecount > push THEN
               INCR n
               INCR push
               a$ = "ARTICLE " + PARSE$(anbr$,crlf$,n+1)
               IF sendline(a$,h) THEN CLOSE fl:EXIT FUNCTION
            END IF
          END IF
      LOOP WHILE push > 0 AND (st& = 220 OR st& >= 400)
      FUNCTION=0
      'discard responses
      FOR push = 1 TO push
           PRINT "          Discarding Articles..."; push;
           b = 0
           DO
              IF linput(a$,h)<0 THEN EXIT FUNCTION
              b = b + LEN(a$)
              LOCATE , 1
              PRINT b;
           LOOP WHILE a$ <> "."
           PRINT
       NEXT
END FUNCTION

FUNCTION getnews(nl$,list$,h)
   FUNCTION=-1
   fnbr=nextfile(h)
   IF getlist(fnbr,nl$,list$,h)< 0 THEN EXIT FUNCTION
   fl=FREEFILE
   OPEN config$(h) FOR BINARY AS fl
   GET$ fl,LOF(fl),rc$
   CLOSE fl
   ' /// v1.10g, kuerzen des RC-Files um eine Zeile verhindern sofern ///
   ' /// abschliessendes CrLf$ fehlt
   IF RIGHT$(rc$, LEN(CrLf$)) <> CrLf$ THEN
       rc$ = rc$ + CrLf$
   END IF
  ' /// v 1.10g, Ende ///

   rctmp$=""
   ngr=PARSECOUNT(rc$,crlf$)
   fnbr=nextfile(h)
   FOR n=1 TO ngr-1
       ng$=PARSE$(rc$,crlf$,n)
       SELECT CASE LEFT$(ng$,1)
              CASE "A" TO "Z","a" TO "z","$"
                   state=readarts(ng$,fnbr,nl$,h)
                   IF state<0 THEN
                      DO
                        rctmp$=rctmp$+ng$+crlf$
                        n=n+1
                        ng$=PARSE$(rc$,crlf$,n)
                      LOOP WHILE n<ngr
                      EXIT FOR
                   END IF
              CASE ELSE
       END SELECT
       rctmp$=rctmp$+ng$+crlf$
   NEXT
   KILL config$(h)
   fl=FREEFILE
   OPEN config$(h) FOR BINARY AS fl
   PUT$ fl,rctmp$
   CLOSE fl
   FUNCTION=0
END FUNCTION

SUB SetConsole
    'This code changes the console window to 80x26...
    DIM Rect    AS LOCAL SMALL_RECT
    ' /// v1.21g, Win32API kompatible
    DIM ScreenMode AS COORD
    ScreenMode.X = 80
    ScreenMode.Y = 26
    SetConsoleScreenBufferSize GETSTDOUT, ScreenMode
    ' /// v1.21g
    Rect.xBottom = 25
    Rect.xRight  = 79
    SetConsoleWindowInfo GETSTDOUT, 1, Rect
END SUB

FUNCTION PostThread(BYVAL h AS LONG) AS LONG
  FOR i=0 TO h-1
    IF commandline(user$,pass$,host$,nl$,list$,port%,i)THEN ITERATE FOR
    IF DIR$(spool$+"\n????.out")="" THEN EXIT FOR
    LogWrite "NNTP Posting Host " + host$, h + i, %LogState_Routing
    IF connectTo(host$,port%,h+i) THEN ITERATE FOR
    LogWrite "NNTP starting...", h + i, %LogState_Routing
    rsp=login(user$,pass$,h+i)
    IF rsp=200 OR rsp=201 THEN
       IF rsp=200 THEN
          IF postnews(h+i)<0 THEN ITERATE FOR
       END IF
       sendcmd "QUIT",ack$,h+i
       LogWrite ack$, h + i, %LogState_Normal
    END IF
  NEXT
END FUNCTION

FUNCTION MainThread(BYVAL h AS LONG) AS LONG
    s=-1
    IF commandline(user$,pass$,host$,nl$,list$,port%,h)THEN EXIT FUNCTION
    LogWrite "NNTP Host " + host$, h, %LogState_Routing
    IF connectTo(host$,port%,h) THEN EXIT FUNCTION
    rsp=login(user$,pass$,h)
    IF rsp<0 THEN EXIT FUNCTION
    IF rsp=200 OR rsp=201 THEN
'       IF rsp=200 AND h=0 THEN postnews(h)
       rsp=getnews(nl$,list$,h)
    END IF
    IF rsp<0 THEN EXIT FUNCTION
    sendcmd "QUIT",ack$,h
    LogWrite ack$, h, %LogState_Normal
END FUNCTION

FUNCTION showstatus$(p)
   LOCAL Az AS ASCIIZ*40
   STATIC t0!
   IF t0!=0 THEN t0!=TIMER
   t1!=TIMER
   dt!=t1!-t0!
   IF dt!>=1 THEN
      allbytes=0
      FOR i=0 TO p-1
          allbytes=allbytes+total(i)
      NEXT
      bytesPerSecond=allbytes\dt!
      Az=LTRIM$(STR$(bytespersecond))+" Bps "+STR$(allbytes)+" Bytes "+STR$(INT(dt!))+" Sek"
      setconsoletitle Az
   END IF
   FUNCTION=Az
END FUNCTION

FUNCTION PBMAIN()
    'setconsole
    'CLS
    $INCLUDE "UKAW.VER"

    SetPriorityClass 1, &h40
    DIM lpr(20) AS DWORD
    DIM lpw(20) AS DWORD
    DIM hs(20) AS DWORD
    DIM rcvbuf(20) AS STRING * %buflen
    DIM hthread(20) AS LONG
    DIM total(20) AS LONG
    DIM Config$(20)
    crlf$ = CHR$(13) + CHR$(10)

    DIM Month$(12)
    Month$(1)  = "JAN"
    Month$(2)  = "FEB"
    Month$(3)  = "MAR"
    Month$(4)  = "APR"
    Month$(5)  = "MAY"
    Month$(6)  = "JUN"
    Month$(7)  = "JUL"
    Month$(8)  = "AUG"
    Month$(9)  = "SEP"
    Month$(10) = "OCT"
    Month$(11) = "NOV"
    Month$(12) = "DEC"

    sLogApp = "E-NEWS "

    p = PARSECOUNT(COMMAND$," ")
    IF COMMAND$ = "" OR INSTR(COMMAND$, "?") > 0 THEN
        STDOUT "E-NEWS " + Version$ + "                           (Freeware sources by Karl-Heinz Weiss)"
        STDOUT "                                                   compilation by " + Author$
        STDOUT " "
        STDOUT "Usage: e-news <newsrc1> <newsrc2>..."
        EXIT FUNCTION
    END IF
    LogOpen
    IF LEN(DIR$("WDial.No")) = 0 THEN
        FOR i=0 TO p-1
            Config$(i) = PARSE$(COMMAND$," ",i+1)
            THREAD CREATE Mainthread(i) TO hThread(i)
            Sleep 1000
        NEXT
        THREAD CREATE postThread(i) TO hthread(i)
        Sleep 1000
        DO
            FOR i = 0 TO p
                Sleep 500
                THREAD STATUS hthread(i) TO result
                IF result = &h103 THEN EXIT FOR
            NEXT
            a$ = ShowStatus$(p)
        LOOP WHILE i <= p
        FOR i = 0 TO p
            IF hs(i) > 0 THEN
                CloseSocket hs(i)
                LogWrite "Closed" + STR$(i), i, %LogState_Normal
            END IF
        NEXT
        LogWrite a$, -1, %LogState_CostInfo
        WSACleanup
    ELSE
        LogWrite sLogApp + "no actice connection!", -1, %LogState_Normal
    END IF
    LogClose
END FUNCTION
