'****************************************************************************
'
' UKAW Paket   : RAS.INC (RasAPI32 Include File)
' Version      : 1.32g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound/CrossPoint
'            or: www.basicguru.com/pbsound-hq/pbsources.win
' Last Updates : see directly in the sources
'
' all original sources by Karl-Heinz Weiss
'
'****************************************************************************


%UNLEN = 256
%PWLEN = 256
%DNLEN = 15
%RAS_MaxEntryName      = 256
%RAS_MaxDeviceName     = 128
%RAS_MaxDeviceType     = 16
%RAS_MaxPhoneNumber    = 128
%RAS_MaxCallbackNumber = 128
%RASCS_Connected       = &h2000

TYPE RASCONNSTATUS
    dwSize       AS DWORD
    rasconnstate AS DWORD
    dwError      AS DWORD
    szDeviceType AS ASCIIZ * %RAS_MaxDeviceType + 1
    szDeviceName AS ASCIIZ * %RAS_MaxDeviceName + 1
    Dummy        AS ASCIIZ * 2
END TYPE

TYPE RASCONN
    dwSize       AS DWORD
    hrasconn     AS DWORD
    szEntryName  AS ASCIIZ * %RAS_MaxEntryName + 1
    szDeviceType AS ASCIIZ * %RAS_MaxDeviceType + 1
    szDeviceName AS ASCIIZ * %RAS_MaxDeviceName + 1
    Dummy        AS ASCIIZ * 1
END TYPE

TYPE RASDIALPARAMS
    dwSize           AS DWORD
    szEntryName      AS ASCIIZ * %RAS_MaxEntryName + 1
    szPhoneNumber    AS ASCIIZ * %RAS_MaxPhoneNumber + 1
    szCallbackNumber AS ASCIIZ * %RAS_MaxCallbackNumber + 1
    szUserName       AS ASCIIZ * %UNLEN + 1
    szPassword       AS ASCIIZ * %PWLEN + 1
    szDomain         AS ASCIIZ * %DNLEN + 1
    Dummy            AS ASCIIZ * 3
END TYPE

TYPE RASENTRYNAME
    dwSize           AS DWORD
    szEntryName      AS ASCIIZ * %RAS_MaxEntryName + 1
    Dummy            AS ASCIIZ * 3
END TYPE

DECLARE FUNCTION RasDial LIB "rasapi32.dll" ALIAS "RasDialA" (BYVAL lpRasDialExtensions AS LONG,BYVAL lpszPhonebook AS LONG, lpRasDialParams AS RasDialParams ,BYVAL dwNotifierType AS LONG,BYVAL lpvNotifier AS LONG,lphras AS LONG) AS LONG
DECLARE FUNCTION RasHangup LIB "rasapi32.dll" ALIAS "RasHangUpA" (BYVAL hrasconn AS DWORD) AS LONG
DECLARE FUNCTION RasEnumEntries LIB "rasapi32.dll" ALIAS "RasEnumEntriesA"(BYVAL LPSTR AS DWORD,BYVAL LPSTR AS DWORD, BYVAL LPRASENTRYNAMEA AS DWORD, LPDWORD AS LONG, LPDWORD AS LONG)AS LONG
DECLARE FUNCTION RasEnumConnections LIB "rasapi32.dll" ALIAS "RasEnumConnectionsA"(BYVAL LPRASCONNA AS DWORD, LPDWORD AS LONG, LPDWORD AS LONG )AS LONG
DECLARE FUNCTION RasGetEntryDialParams LIB "rasapi32.dll" ALIAS "RasGetEntryDialParamsA"(BYVAL LPSTR AS DWORD, LPRASDIALPARAMS AS RasDialParams, LPBOOL AS LONG)as long
DECLARE FUNCTION RasGetErrorString LIB "rasapi32.dll" ALIAS "RasGetErrorStringA" (BYVAL hRasError AS LONG, hRasErrorBuff AS ASCIIZ, BYVAL hRasErrorBufLen AS DWORD) AS DWORD
DECLARE FUNCTION RasGetConnectStatus LIB "rasapi32.dll" ALIAS "RasGetConnectStatusA" (BYVAL HRASCON as DWORD, LPRASCONNSTATUS AS RASCONNSTATUS) AS DWORD                                                            

DECLARE FUNCTION GetRasError (RasError AS LONG) AS STRING

FUNCTION GetRasError(RasError AS LONG) AS STRING
        DIM RasErrorBuff AS ASCIIZ * 512     ' Buffer mit Win-Zeichensatz
        DIM RasErrorText AS ASCIIZ * 512     ' Buffer mit DOS-Zeichensatz
        RasErrorBuffLen?? = 512              ' Sollte immer 512 sein, da
                                             ' unter NT auch Unicode bis zu
                                             ' 512 Bytes/Char zurckgegeben
                                             ' werden knnen!
        i& = RasGetErrorString(RasError&, RasErrorBuff$, RasErrorBuffLen??)
        CharToOEM RasErrorBuff, RasErrorText 
        FUNCTION = RasErrorText
END FUNCTION